#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include <unistd.h>
#include <errno.h>

#include <fcntl.h>
#include <sys/stat.h>  

typedef struct bufferi
{
    ssize_t alku;
    ssize_t size;
}buff;

#define debug1 printf("** Debug: "
#define debug2 );__debug();

static unsigned char *b;
static buff source;

static ssize_t swap_loppu, table_loppu;

static ssize_t SourcePtr, SourceEnd;
static ssize_t dest_alku, dest_ptr;
static ssize_t swap_ptr, table_ptr;

#define source_ptr SourcePtr

static char *sourcename="in";
static char *destname="out";

static int ok;
static int synerr;
static long Riveja;

/******************************************************/
static unsigned long Rivinro(int tulo)
{
    ssize_t ptr, vpos;
    unsigned rivi=1;
    for(ptr=vpos=source.alku; ptr!=SourcePtr; ptr++)
        if(b[ptr]=='\n')
        {
            rivi++;
            vpos = ptr + 1;
        };
    if(tulo)printf("At line %u: ", rivi);
    return vpos;
}
static void __debug(void)
{
    ssize_t vpos;
    puts("");
    vpos=Rivinro(1);
    while(vpos != SourceEnd && b[vpos]!=10)putchar(b[vpos++]);
    puts("");
}
/******************************************************/
static void CleanUp(int code)
{
    if(b)free(b);
    exit(code);
}
/******************************************************/
static void destout(void);
static void virhe(const char *string)
{
    ssize_t haku, c;

    printf("\33[1m\r%s\33[m\n", string);
    if(errno)printf("Error %d: %s\n", errno, sys_errlist[errno]);
    if(synerr)
    {
        ssize_t vpos=Rivinro(1);
        while(vpos != SourceEnd && b[vpos]!=10)
        {
            if(b[vpos]!=13)putchar(b[vpos]);
            vpos++;
        }
        puts("");
    }
    for(c=0, haku=table_ptr; haku < table_loppu; c++)
    {
        haku += (int)b[haku]+1;
        haku += (int)b[haku]+1;
    }

    if(table_ptr < table_loppu)
    {
      int i;
      printf("Taulukossa on %u elementti, viimeksi listty: \"", c);
      haku=table_ptr;
      for(i=0; i<(int)b[haku]; i++)putchar(b[haku+i+1]);
      printf("\" = \"");
      haku += (int)b[haku] + 1;
      for(i=0; i<(int)b[haku]; i++)putchar(b[haku+i+1]);
      printf("\"\n");
    }

    destout();

    CleanUp(errno?errno:1);
}
/******************************************************/
static void table_insert(buff string, buff value)
{
    if(string.size > 255 || value.size > 255)                   virhe("String too long 'table_insert'");
    if((table_ptr -= string.size + value.size + 2) < swap_loppu)virhe("Out of memory 'table_insert'");
    b[table_ptr] = (char) string.size;
    memcpy(&b[table_ptr + 1], &b[string.alku], (int)string.size);
    b[table_ptr + string.size + 1] = (char) value.size;
    memcpy(&b[table_ptr + string.size + 2], &b[value.alku], (int)value.size);
}
/******************************************************/
static void destout(void)
{
    int fh;
    ssize_t size;
  
    fh = open (destname, O_WRONLY|O_CREAT|O_TRUNC, S_IREAD|S_IWRITE);
    if(fh==-1) virhe("Ei saa auki! 'destout'");
    size = dest_ptr-dest_alku;
    
    if(write(fh, &b[dest_alku], size) != (ssize_t)size)
        virhe("kaikki ei mennyt levylle.");

    if(close(fh)) virhe("Crash! 'destout'");
}
/******************************************************/
static void sourcein(void)
{
    int fh;
    ssize_t size, result;
  
    fh = open (sourcename, O_RDONLY);
    if(fh==-1)
    {
        printf("'%s' ", sourcename);
        virhe("virhe");
    }
    size = lseek(fh,0,SEEK_END);
    lseek(fh,0,SEEK_SET);
    
    if(size > swap_ptr-dest_ptr)
    {
        printf("Sourcefile size is %d bytes and free memory %d bytes. ",
               size, swap_ptr-dest_ptr);
        virhe("Stop.");
    }
    SourceEnd = swap_ptr;
    source.alku = (swap_ptr -= (source.size = size));
    result = read(fh, &b[source.alku], size);
    if(result != size)virhe("Kaikkea ei saatu luettua.");
    if(close(fh)) virhe("Crash! 'sourcein'");
    SourcePtr = swap_ptr;
}
/******************************************************/
static void Add(buff muisti)
{
    ssize_t ptr, size;
    if(dest_ptr+muisti.size > swap_ptr) virhe("Out of memory 'Add'");
    if(muisti.size > 0xffff) virhe("Liian suurta 'Add'");

    ptr=muisti.alku;
    size=muisti.size;
    while(size)
    {
        if((b[dest_ptr++] = b[ptr++])=='\n')
            Riveja++;
        size--;
    }
}
/******************************************************/
static void Gen(const char *string)
{
    while(*string)
    {
        if(dest_ptr==swap_ptr)virhe("Out of memory 'Gen'");
        if((b[dest_ptr++]=(unsigned char)*(string++))=='\n')
            Riveja++;
    }
}
/******************************************************/
static void table_search(buff string)
{
    ssize_t haku = table_ptr;
    buff result;

    while(haku < table_loppu)
    {
        if((char) string.size == b[haku]
            && !memcmp(&b[haku + 1], &b[string.alku], (int)string.size))
        {
            haku = haku + (int)b[haku] + 1;
            result.size = (long) b[haku];
            result.alku = haku + 1;
            Add(result);
            ok = 1;
            return;
        }
        haku = haku + (int)b[haku] + 1;
        haku = haku + (int)b[haku] + 1;
    }
    ok = 0;
}
/******************************************************/
static unsigned char nextin(void)
{
    if(SourcePtr==SourceEnd)return ok=0;
    {
        register unsigned char tmp = b[SourcePtr++];
        if(tmp=='\n')Riveja++;
        return tmp;
    }
}
static unsigned char testraja(unsigned char r1, unsigned char r2)
{
    if(SourcePtr==SourceEnd)return ok=0;
    {
        register unsigned char tmp = b[SourcePtr++];
        if(tmp=='\n')Riveja++;
        return tmp>=r1 && tmp<=r2;
    }
}
static unsigned char TeStRaja(unsigned char r1, unsigned char r2)
{
    if(SourcePtr==SourceEnd)return ok=0;
    {
        register unsigned char tmp = b[SourcePtr++];
        if(tmp=='\n')Riveja++;else tmp=toupper(tmp);
        return tmp>=toupper(r1) && tmp<=toupper(r2);
    }
}
/******************************************************/
static int Test(const char *string)
{
    ssize_t ptr=SourcePtr;
    while(*string && (ok=((unsigned char)*string==b[ptr]))) ptr++, string++;
    return ok ? SourcePtr=ptr, 1 : 0;
}
/******************************************************/
static int TeSt(const char *string)
{
    ssize_t ptr=SourcePtr;
    while(*string && (ok=(toupper(*string)==toupper(b[ptr])))) ptr++, string++;
    return ok ? SourcePtr=ptr, 1 : 0;
}
/******************************************************/
static void lower(buff muisti)
{
    unsigned char *p = &b[muisti.alku];
    ssize_t i = muisti.size;
    while(i)
    {
        *p = (unsigned char)tolower(*p);
        p++;
        i--;
    }
}
/******************************************************/
static void upper(buff muisti)
{
    unsigned char *p = &b[muisti.alku];
    ssize_t i = muisti.size;
    while(i)
    {
        *p = (unsigned char)toupper(*p);
        p++;
        i--;
    }
}
/******************************************************/
static void load_file(buff nimi, buff *paikka)
{
    int fh;
    ssize_t result;
  
    char buffer[13];
  
    if(nimi.size > 12)
    {
        printf("'");
        fwrite(&b[nimi.alku], 1, nimi.size, stdout);
        printf("':");
        virhe("liian pitk tiedostonimi");
    }
    memcpy(buffer, &b[nimi.alku], nimi.size);
    buffer[nimi.size] = 0;
  
    fh = open (buffer, O_RDONLY);
    if(fh==-1)
    {
        printf("'");
        fwrite(&b[nimi.alku], 1,  nimi.size, stdout);
        printf("' ");
        virhe("virhe");
    }
    paikka->size = lseek(fh,0,SEEK_END);
    lseek(fh,0,SEEK_SET);
    
    if(paikka->size > swap_ptr-dest_ptr) virhe("Lhdetiedosto on liian iso.");;
    paikka->alku = (swap_ptr -= paikka->size);
    result = read(fh, &b[paikka->alku], paikka->size);
    if(result != paikka->size ) virhe("Lhdetiedosto on liian iso.");
    if(close(fh)) virhe("Lhdetiedostoa ei saatu suljettua; DOS-vika.");
}
/******************************************************/
static void vie(ssize_t paikasta, buff *muisti)
{
    ssize_t size = dest_ptr-paikasta;
    if(size>0xffff) virhe("Liian suurta 'vie'");
    if((swap_ptr -= size) < dest_ptr) virhe("Muisti loppuu 'vie'");
    memcpy (&b[swap_ptr], &b[paikasta], size);
    dest_ptr = paikasta;
    muisti->alku = swap_ptr;
    muisti->size = size;
}
/******************************************************/
/* inline koodissa kytettv konversiofunktio        */
/* generoi annetusta numerosta integerin              */
/******************************************************/
static int integer(buff muisti, int radix)
{
    char buffer[7];  
    if(muisti.size>6) muisti.size=6;
    memcpy(buffer, &b[muisti.alku], muisti.size);
    buffer[muisti.size]=0;
    return strtol(buffer, NULL, radix);
}
/******************************************************/
/* inline koodissa kytettv konversiofunktio        */
/* generoi annetusta integerist merkkijonon          */
/******************************************************/
static void intstr(int luku)
{
    char Buffer[12];
    sprintf(Buffer, "%d", luku);
    Gen(Buffer);
}
/******************************************************/
static void Text(buff What)
{
    while(What.size)
    {
        putchar(b[What.alku++]);
        What.size--;
    }
}
/******************************************************/
int main(int argc, char **argv)
{
    if(--argc)
    {
    	sourcename=*++argv;
	    if(--argc)destname=*++argv;
	}

    swap_loppu = 300000;
    table_loppu = 320000;

    SourcePtr=SourceEnd=dest_alku=dest_ptr=0;
    Riveja=synerr=0;

    b = NULL;

    swap_ptr=swap_loppu;
    table_ptr=table_loppu;

    ok = 1;
	b = (unsigned char *)calloc(table_loppu, 1);
    if(!b)
    {
        printf("Muistia on liian vhn kntjn tarpeisiin.\n");
        CleanUp(-1);
    }
  
    sourcein();
  
    ok=synerr=1;
    S_syntaksikuvaus();
  
    Test("\x1A");
    ok=(SourcePtr==SourceEnd);
    if(!ok)virhe("Raportissa oli virhe, jota ei lydetty.");
    if(SourcePtr!=SourceEnd) virhe("Sorsaa ei saada lopetettua!");

    destout();
  
    CleanUp(0);
    return 0;
}
/******************************************************/
/* inline koodissa kytettv konversiofunktio        */
/* generoi annetusta heksakoodista merkin tulokseen   */
/******************************************************/
static void genchar(buff muisti)
{
    int tulos;
    sscanf((char *)&b[muisti.alku], "%2X", &tulos);
    if(tulos==26)
        Gen("\\x1A");
    else
    {
        b[dest_ptr++]=(unsigned char) tulos;
        if(dest_ptr>swap_ptr) virhe("Out of memory");
    }
}
/******************************************************/
static void DoVirhe(void)
{
    buff B;
    int c;
    B.alku=SourcePtr;
    for(c=0;c<20;c++)nextin();
    B.size=SourcePtr-B.alku;
    printf("At this point: \"");
    Text(B);
    printf("\"\n");
}
static int space(void)
{
  while (isspace(b[SourcePtr]) && SourcePtr!=SourceEnd) SourcePtr++;
  return 0;
}
static int tuotaint(ssize_t luku)
{
	char jono[20], *string = jono;
	
	sprintf(string, "%d", luku);

	while (*string && dest_ptr != swap_ptr) b[dest_ptr++]=*(string++);
	if (dest_ptr==swap_ptr) virhe("Out of memory 'tuotaint'");
	return 0;
}
